using System;
using System.Data;
using System.Data.Sql;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using System.Collections;

public partial class FData : IEnumerator, IEnumerable
{
	// the previous number in the sequence
	int previous_;
	// the current number in the sequence
	int current_;
	int count_;
	int maxCount_;
    int preStart;
    int start;

	internal FData(int preStart, int start, int count)
	{
        this.preStart = preStart;
        this.start = start;
		previous_ = preStart;
		current_ = start;
		maxCount_ = count;
		this.count_ = 0;
	}

	// One IEnumerable method
	public IEnumerator GetEnumerator()
	{
		return this;
	}
	
	// Three IEnumerator methods.
	public bool 	MoveNext ()	
	{
		// just leave things as they are
		// for the first time though
		if (count_ != 0)
		{
			int p = current_;
			current_ += previous_;
			previous_ = p;
		}
		// move to next number in sequence
		count_ = count_ + 1;
		if (count_ > maxCount_)
		{
			// done with sequence
			return false;
		}
		return true;
	}
	public object 	Current 	{  get  { return this; } }
	public void 	Reset ()	
	{
		this.count_ = 0;
        previous_ = preStart;
        current_ = start;
        
	}

	// Two Tvf contract methods
	[Microsoft.SqlServer.Server.SqlFunction(FillRowMethodName = "FillRow",TableDefinition="next int, prev int")]
	public static IEnumerable Fibonacci(int a, int b, int c)
	{
		return new FData(a,b,c);
	}

	public static void FillRow(Object obj, out int nextout, out int prevout)
	{
		FData f = (FData)obj;

		nextout = f.current_;
		prevout = f.previous_;
	}

};

